Page MenuHomePhabricator

Reply tool doesn't always work on signatures from the {{unsigned}} or {{user link}} templates
Closed, ResolvedPublic

Description

This has been reported on multiple wikis, including on arwiki and at https://nl.wikipedia.org/wiki/Wikipedia:Discussietools#Feedback_op_de_Antwoordentool

Editors often forget to sign and date their comments. It's common in larger wikis to use a template such as https://en.wikipedia.org/wiki/Template:Unsigned2:

"— Preceding unsigned comment added by Example (talk • contribs) 13:45, 28 February 2010 (UTC)"

The links to the user's name, talk, and contributions pages are provided through https://en.wikipedia.org/wiki/Template:User_link.

If the date is passed through the template the "Reply" button fails to launch the tool.

Event Timeline

Restricted Application added subscribers: Liuxinyu970226, Aklapper. · View Herald TranscriptApr 17 2020, 6:53 PM

They should be recognized if the date/time is also added (it must be in the same format as normal signatures). Can you give links to pages where it doesn't work?

Thanks for reporting this one. First of all, we tested a bit on the talkpage of the linked page on nlwiki, it seems that the reply tool is triggered by the time stamp. If you just add the timestamp behind the template, there is a reply button. However, if you use the template functionality to add the date however, there is a reply button, but small as the template text, and it doesn't work. See the talkpage.

Secondly another one I suggested, not sure if it is good to mix those, if the last comment is unsigned, which is of course quite common, it seems a good idea to add a reply button always. That point should be recognized as it will be either End of File or followed by a next section. That will likely fix the bulk of the unsigned cases.

They should be recognized if the date/time is also added (it must be in the same format as normal signatures). Can you give links to pages where it doesn't work?

https://nl.wikipedia.org/wiki/Overleg_Wikipedia:Discussietools for several examples.

Lofhi added a subscriber: Lofhi.Apr 22 2020, 1:04 PM

Same on frwiki for {{Non signé}} and {{Non signé2}}. I have planned to update them, since it seems needed.

During yesterday's team meeting, we came up with some initial ideas for what could be done to make the Reply tool compatible with unsigned comment templates. Those ideas/approaches are listed in the comment below this one.

First, some notes:

  1. Before picking an initial approach and prioritizing this work, I would like for us to understand how templates like {{unsigned}} end up on pages in the first place.
    • For example: are these templates most typically added on a one-off basis by the person responding to someone who didn't sign their comment? Are they added en masse using a tool like Twinkle?
    • To this end, I've posted a comment asking as much on nl.wiki: https://w.wiki/PVF.
    • In parallel, @AdHuikeshoven, @Dyolf77_WMF, @Lofhi, @Whatamidoing-WMF and anyone else here: do any of you have insight about the ways in which templates like {{unsigned}} typically get added and/or do you know other people who may?
  2. I wonder how impactful this issue will be in the not-so-distant future when, I assume, unsigned comments are less common because of the deployment and adoption of the new Replying and New Discussion tool.

Potential approaches
This is list of preliminary ideas. In no particular order:

  1. Idea: ask wikis to update unsigned templates that do not make the timestamp required (e.g. {{Non signé}})
    • Notes: previously unsigned comments would not be supported; adoption of this new requirement could be low considering the work involved with fulfilling it (read: manually checking page history).
  1. Idea: use Parsoid to detect unsigned templates and append "Reply" links to those.
    • Notes: an intermediate step to "full" support could involve using Wikidata to compile a preliminary list of unsigned comment templates, ask volunteers to review the list and identify those actually in use that we would then in turn recognize/support.
JJMC89 added a subscriber: JJMC89.Apr 30 2020, 4:19 AM
  1. Before picking an initial approach and prioritizing this work, I would like for us to understand how templates like {{unsigned}} end up on pages in the first place.
    • For example: are these templates most typically added on a one-off basis by the person responding to someone who didn't sign their comment? Are they added en masse using a tool like Twinkle?
  • bots (e.g., SineBot and SignBot)
    • The most common method on the English Wikipedia.
  • scripts (e.g. Anomie's unsignedhelper)
  • manual additions
    • while replying
    • a watcher just noticng that a comment is unsigned
Lofhi added a comment.Apr 30 2020, 1:30 PM

Same observations for frwiki. Though, we have only one bot for this purpose : Signature manquante (bot). The manual additions are more common too.

It sounds like on nl.wiki, unsigned comment templates are added on a one-off basis as individuals notice them in the course of replying to an unsigned comment.

See Special:Diff/56175723:

cc @Mbch331

ppelberg added a subscriber: Samat.May 6 2020, 1:03 AM
  • bots (e.g., SineBot and SignBot)
    • The most common method on the English Wikipedia.
  • scripts (e.g. Anomie's unsignedhelper)
  • manual additions
    • while replying
    • a watcher just noticng that a comment is unsigned

Same observations for frwiki. Though, we have only one bot for this purpose : Signature manquante (bot). The manual additions are more common too.

@JJMC89 + @Lofhi: the context you shared above is helpful. Specifically, the links to the scripts and bots you recall being used most ...thank you.


As for next steps, I would like us to better understand how unsigned comments are handled at our other partner wikis: Arabic and Hungarian.

With this in mind, @Dyolf77_WMF and @Samat are you able to help us answer the following questions for the Arabic and Hungarian Wikipedias respectively?

  • 1. Are templates typically added to unsigned comments?
  • 2. If so, which unsigned templates are added?
  • 3. What are the ways (e.g. en masse via script(s)/bot(s), manually, etc) in which these unsigned templates are added?
  • 4. If unsigned templates are added en masse, what scripts and bots are used on your wiki?

In ar.wiki there is a bot that places a template after unsigned comments, but it is out of service now. Its creator is not available at the moment so the bot is stopped. Thus unsigned comments are now handled by editors who place the template manually!

My comment above was too quick so these are my answers:
For AR wiki:

  • 1. Are templates typically added to unsigned comments?

Yes

  • 2. If so, which unsigned templates are added?

this template: https://ar.wikipedia.org/wiki/%D9%82%D8%A7%D9%84%D8%A8:%D8%BA%D9%8A%D8%B1_%D9%85%D9%88%D9%82%D8%B9

  • 3. What are the ways (e.g. en masse via script(s)/bot(s), manually, etc) in which these unsigned templates are added?

the template is added manually (there was a bot, but no more active now)

  • 4. If unsigned templates are added en masse, what scripts and bots are used on your wiki?

No

Esanders renamed this task from Reply tool doesn't detect signatures from the {{unsigned}} or {{user link}} templates to Reply tool doesn't detect signatures from the {{unsigned}} or {{user link}} templates if no timestamp provided.May 6 2020, 2:56 PM
Esanders updated the task description. (Show Details)
Esanders renamed this task from Reply tool doesn't detect signatures from the {{unsigned}} or {{user link}} templates if no timestamp provided to Reply tool doesn't detect signatures from the {{unsigned}} or {{user link}} templates.May 6 2020, 3:02 PM
Esanders updated the task description. (Show Details)

There are two issues I see that may be able to be addressed in the code:

  1. In the example here the reply link is shown but doesn't work due to it being in a template: https://nl.wikipedia.org/wiki/Overleg_Wikipedia:Discussietools#Bericht_zonder_afzender_met_{{afz}}_en_tijdstempel_in_sjabloon
  2. In the example here the signature is not detected, probably because the timestamp is a link: https://fr.wikipedia.org/wiki/Discussion:Odile_Fillod
Esanders renamed this task from Reply tool doesn't detect signatures from the {{unsigned}} or {{user link}} templates to Reply tool doesn't always work on signatures from the {{unsigned}} or {{user link}} templates.May 6 2020, 3:04 PM

I want to make again a suggestion I have given above, but seems to be missed. Often the unsigned comment is the last comment. I think that that case should be much more easy to recognize, as it will be followed by a header, so it is clear that it is the end of the discussion. Doesn't it make sense to at least always put a reply button at the end of the discussion?

Ok, clear. But if there are signatures in a section, and there is not a signature at the end, that should at least be safe?

Probably? But someone would have to check (and not just at enwiki) to see whether our guess is correct.

@ppelberg will create a ticket for supporting unsigned templates that haven't been substituted.

Let's also create one for linked timestamps (2)

I want to make again a suggestion I have given above, but seems to be missed. Often the unsigned comment is the last comment. I think that that case should be much more easy to recognize, as it will be followed by a header, so it is clear that it is the end of the discussion. Doesn't it make sense to at least always put a reply button at the end of the discussion?

Ok, clear. But if there are signatures in a section, and there is not a signature at the end, that should at least be safe?

One counter-example would be a <references /> tag at the bottom of the section, which I've seen once or twice ;) (I don't think we should be seriously thinking about this as more important than unsigned comments, just saying that the approach might not always work)

But I don't think this would be feasible to implement. We've made a big assumption in the current code that comments always have a timestamp, and everything relies on it now. The replying tool basically doesn't "see" unsigned comments at all, they are completely ignored, like e.g. the wikiproject templates on top of article talk pages. And we rely on the timestamps (and some other things) to insert the reply in the right place in the wikitext, or to find the comment when it's transcluded from another page. We really can't insert replies to unsigned comments.

Lofhi added a comment.May 7 2020, 12:37 PM

I can ask a modification of the templates on frwiki, if needed.

Samat added a comment.May 17 2020, 7:45 PM

With this in mind, @Dyolf77_WMF and @Samat are you able to help us answer the following questions for the Arabic and Hungarian Wikipedias respectively?

  • 1. Are templates typically added to unsigned comments?

It is quite typical, yes. (In many cases with negative tone and comments, that why did not you signed. This makes me often sad especially in case of applied with newcomers. One reason I was waiting for the improvements for talk and discussion pages, is to avoid this behavior.)

  • 2. If so, which unsigned templates are added?

https://hu.wikipedia.org/wiki/Sablon:Al%C3%A1%C3%ADratlan is the main template (or at least I use the most), but there are alternatives, like
https://hu.wikipedia.org/wiki/Sablon:Pot
https://hu.wikipedia.org/wiki/Sablon:Szerz%C5%91
etc.

  • 3. What are the ways (e.g. en masse via script(s)/bot(s), manually, etc) in which these unsigned templates are added?

We do not use script/bot for it, so they are only manually inserted. (There are frequent requests for a singing bot, but nobody did it until now. I hope that MediaWiki will solve this issue globally and there will be no need of local bots on each project for this purpose.)

  • 4. If unsigned templates are added en masse, what scripts and bots are used on your wiki?

They are added manually.

Samat added a comment.May 17 2020, 7:46 PM

I can ask a modification of the templates on frwiki, if needed.

I love that the time stamp links to the diff, I would make it default everywhere :)

I can ask a modification of the templates on frwiki, if needed.

@Lofhi Is it possible to remove the full-stop (.) from the end of https://fr.wikipedia.org/wiki/Modèle:Non_signé? I started the work on replying to comments signed using that template, and the full-stop after the timestamp is making it more difficult – the existing code doesn't expect anything after the signature and timestamp.

Lofhi added a comment.May 27 2020, 9:02 PM

I thought the same thing when I was looking at the model when this ticket was opened. The full stop has been kept since the creation of the template in 2007... imported from enwiki.

You must be happy: this model is not substituted on frwiki (may change one day), unlike enwiki. Retroactive change! 😄

I will ask an administrator to edit this template, it should not be a problem.

This issue surfaced at ko.wiki [i] where a [ reply ] link is NOT appearing after this comment [ii].

Question

  • @matmarex, is the above another case [iii] where changes will need to be made to the ko.wiki's {{unsigned}} template for reply links to appear on comments that use iti?

cc @Whatamidoing-WMF


i. https://w.wiki/YoF
ii. 역이나 학교 같은 문서를 보면 템플릿 같은게 있어보이는데 어떻게 찾나요? -- 이 의견을 2020년 8월 2일 (일) 23:35‎ (KST)에 작성한 사용자는 Jeong1234 (토론)이나, 서명을 남기지 않아 다른 사용자가 추가하였습니다. 의견을 남기실 때에는 항상 의견 끝에 띄어쓰기를 하고 --~~~~를 입력해 주세요. 저장할 때 자동으로 서명이 됩니다.
iii. T250516#6170724
iv. https://ko.wikipedia.org/wiki/%ED%8B%80:%EC%84%9C%EB%AA%85

@ppelberg needs to file a subtask for the issue he raised in the comment above.

@ppelberg needs to file a subtask for the issue he raised in the comment above.

Done; the task is here: T259737.

All of the subtasks are fixed.

DiscussionTools should now support all "unsigned" templates on all wikis, both substituted and not, as long as their output is similar to normal signatures:

  • It must include a link to the user page, talk page or contributions
  • It must include a date and time (a "timestamp"), in the same format as in signatures, including the timezone in parentheses
  • The link must be before the date and time (like in normal signatures)

We rely on the username and timestamp to identify which comment you're responding to, so unfortunately these requirements are not possible to change.

If a template isn't recognized on your wiki, and you're sure it meets the requirements above, please file another bug. We're happy to support minor differences compared to normal signatures, for example: (these are things that are already supported)

  • The timestamp being linked to the revision where the comment was added (as seen on fr.wp)
  • Other text following the signature (as seen on ko.wp)
  • Inconsistent user of upper/lower case in IPv6 addresses (as seen on en.wp)
  • Using the wrong timezone abbreviation for daylight savings time (as seen on pl.wp)

@matmarex: thank you for writing out this guidance explicitly [i]; I've added it to the Help:DiscussionTools/Why can't I reply to this comment? page.[ii]

Note: I'm waiting to mark this ticket as "Resolved" until we answer the question posed in T252058#6407874.


i. T250516#6407325
ii. https://www.mediawiki.org/w/index.php?title=Help%3ADiscussionTools%2FWhy_can%27t_I_reply_to_this_comment%3F&type=revision&diff=4054713&oldid=4034468

ppelberg closed this task as Resolved.Aug 27 2020, 3:41 PM
ppelberg claimed this task.

Note: I'm waiting to mark this ticket as "Resolved" until we answer the question posed in T252058#6407874.

Done. See: T252058#6416217.